ausListe :: [a] -> Liste a 
ausListe = foldr cons leer

kopf :: Liste a -> a 
kopf (L [])                      = error "Kopf einer leeren Liste" 
kopf (L ((_,Knoten a _ _):_))    = a

rest :: Liste a -> Liste a 
rest (L ((1,_):ts))              = L ts 
rest (L ((n,Knoten _ t1 t2):ts)) = let n' = n `div` 2 
                                   in L ((n',t1):(n',t2):ts) 
rest _                           = error "Rest einer leeren Liste"

nachListe :: Liste a -> [a] 
nachListe = unfoldr f where     
	f l
        | null l    = Nothing
        | otherwise = Just (kopf l, rest l)
