import Data.Char -- fuer toLower
import System.IO -- fuer hSetBuffering

-- das zu erratende Wort und die Anzahl der Versuche
wort        = "Lambda" 
maxVersuche = 5

-- im String werden die bereits geratenen Buchstaben
-- gespeichert. Im Int die Zahl der falschen Versuche
hangman :: String -> Int -> IO ()
hangman geraten falsch
    {- wenn man mehr falsche Versuche hatte, als erlaubt,
       hat man verloren. Wenn man alle Buchstaben des
       Wortes erraten hat, hat man gewonnen -}
    | falsch > maxVersuche = putStrLn "\nverloren"
    | all (`elem` geraten) (map toLower wort) = putStrLn "\ngewonnen"
hangman geraten falsch = do
    putStrLn ""
    printWord geraten
    putStrLn "\nWelcher Buchstabe?"
    -- ein Zeichen einlesen und zu einem Kleinbuchstaben machen
    c <- getChar >>= (return.toLower) 
    -- testen, ob der Buchstabe vorkommt
    if (c `elem` (map toLower wort)) then 
        hangman (c:geraten) falsch else do
            -- falls nicht die Anzahl der Fehlversuche erhoehen
            putStrLn $ "\n" ++ (show (falsch+1)) ++ " falsch!\n"
            hangman geraten (falsch+1)

{- gibt das Wort aus, zeigt aber nur die geratenen Buchstaben an.
   Noch nicht geratene Buchstaben werden durch ein _ ersetzt. -}
printWord :: String -> IO ()
printWord geraten = mapM_ putZeichen wort where -- mapM = sequence.map
    putZeichen x
         | toLower x `elem` geraten = putChar x
         | otherwise = putChar '_'

main = do
    hSetBuffering stdin NoBuffering
    hangman "" 0
