-- prueft, ob die Liste leer ist
null :: List a -> Bool
null Nil = True
null _   = False

-- liefert das erste Element der Liste
head :: List a -> a
head (Cons a _)     = a
head _              = error "head auf leerer Liste"

-- liefert den Rest der Liste ohne erstes Element
tail :: List a -> List a
tail (Cons _ r)     = r
tail Nil            = error "tail auf leerer Liste"

-- konkateniert zwei Listen
concat :: List a -> List a -> List a
concat Nil x        = x
concat (Cons a r) x = Cons a (concat r x)

-- fuehrt eine Funktion f auf alle Listenelemente aus
map :: (a -> b) -> List a -> List b
map _ Nil           = Nil
map f (Cons a r)    = Cons (f a) (map f r)
