module Adressbuch (
    Name,
    Adresse,
    Adressbuch,
    leeresAdressbuch,
    einfuegen,
    finde,
    aktualisiere) where

import qualified Woerterbuch as W

type    Name       = String
type    Adresse    = String
newtype Adressbuch = A (W.WBuch Name Adresse) deriving Show

toWBuch (A d) = d
fromWBuch  d  = A d

leeresAdressbuch :: Adressbuch
leeresAdressbuch = fromWBuch W.leeresWBuch

einfuegen :: (Name, Adresse) -> Adressbuch -> Adressbuch
einfuegen x = fromWBuch . W.einfuegen x . toWBuch

finde :: Name -> Adressbuch -> Maybe Adresse
finde n = W.finde n.toWBuch

aktualisiere :: (Name, Adresse) -> Adressbuch -> Adressbuch
aktualisiere (name, newAdress) (A dic) = 
    let dic' = W.loesche name dic in 
               einfuegen (name, newAdress)  (fromWBuch dic')
