data Queue a = Q Int [a] Int [a]

null :: Queue a -> Bool
null (Q 0 _ _ _) = True
null _ = False

queue n x m y 
    | n > m     = Q n x m y
    | otherwise = Q (n+m) (x++reverse y) 0 []

enqueue :: a -> Queue a -> Queue a
enqueue a (Q n x m y)    = queue n x (m+1) (a:y)

dequeue :: Queue a -> (a, Queue a)
dequeue (Q n (x:xs) m y) = (x, queue (n-1) xs m y)
