module Woerterbuch (
    WBuch,
    leeresWBuch,
    einfuegen,
    finde,
    loesche) where

newtype WBuch k v = D [(k,v)] deriving Show

leeresWBuch :: Eq k=> WBuch k v
leeresWBuch       = D []

einfuegen :: (k, v) -> WBuch k v -> WBuch k v
einfuegen x (D l) = D (x:l)

finde :: Eq k => k -> WBuch k v -> Maybe v
finde k (D l)     = lookup k l

loesche :: Eq k => k -> WBuch k v -> WBuch k v
loesche key (D l) = D [(k,v) | (k,v) <- l, k/=key]
